/*
 * #%L
 * Wikitty :: api
 * 
 * $Id: JRSTConfigAction.java 700 2012-06-07 15:40:15Z maven-release $
 * $HeadURL: http://svn.nuiton.org/svn/jrst/tags/jrst-2.0.1/jrst/src/main/java/org/nuiton/jrst/JRSTConfigAction.java $
 * %%
 * Copyright (C) 2011 CodeLutin, Chatellier Eric
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * #L%
 */

package org.nuiton.jrst;

import org.nuiton.util.ApplicationConfig.ActionDef;

import static org.nuiton.i18n.I18n._;
import static org.nuiton.i18n.I18n.n_;

/**
 * JRST actions.
 * 
 * @author echatellier
 */
public enum JRSTConfigAction implements ActionDef {
    HELP(n_("JRST help"), JRSTConfig.class.getName() + "#help", "-h", "--help");

    public String description;
    public String action;
    public String[] aliases;

    private JRSTConfigAction(String description, String action, String... aliases) {
        this.description = description;
        this.action = action;
        this.aliases = aliases;
    }

    public String getDescription() {
        return _(description);
    }

    @Override
    public String getAction() {
        return action;
    }

    @Override
    public String[] getAliases() {
        return aliases;
    }

}
